package registrojdbc;

import java.sql.*;
import java.util.*;

public class InterfaceBaseDatosRegistro
{
    private Connection con;
    private Statement stmt;
    private ResultSet rs;
    private boolean checkDriver = false;
    protected boolean fg;
        
    public InterfaceBaseDatosRegistro()
    {
        int fg = revisarDriverSun();
        if (fg == 0)
              checkDriver = true; // abrirConexion("jdbc:odbc:reservaciones", "alfredo", "ITAM");  // nombre debe corresponder
    }
    public String getClassName(Datos reg){
        String regname;
        Class regclass = reg.getClass();
        String fullname = regclass.getName();
        int index = fullname.lastIndexOf('.');
        if (index > 0)
                regname = fullname.substring(index+1);
        else
                regname = fullname;
        return regname;
    }
    public void abrir() {
	System.out.println ("\n*** Abriendo Conexion ***\n");
        abrirConexion("jdbc:odbc:reservaciones", "alfredo", "ITAM");  // nombre debe corresponder	
    }
    private void abrirConexion(String url,String log,String pass)
    {
        try {
          // DriverManager.setLogStream(System.out);
          // Intenta conectarse al Driver. Cada uno de
          // los drivers registrados sern cargados hasta
          // que se encuentre el que pueda procesar la url
          // especificada
          con = DriverManager.getConnection (url, log, pass);
          // Si no es posible conectarse, se generar un error
          // que podra ser identificada. De lo contrario, si obtiene
          // la URL se conectar satisfactoriamente.
          // Checa y despliega los mensajes generados por la conexin
          checkForWarning (con.getWarnings ());
          // Obtiene el objeto DatabaseMetaData y despliega
          // Informacin acerca de la conexin.
          DatabaseMetaData dma = con.getMetaData ();
          System.out.println("\nConectado a " + dma.getURL());
          System.out.println("Driver       " + dma.getDriverName());
          System.out.println("Versin      " + dma.getDriverVersion());
          System.out.println("");
          // Crea el objeto Statement para poder introducir
          // instrucciones de SQL al driver
          stmt = con.createStatement ();
        }
        catch (SQLException ex) {
            System.out.println ("\n*** Error de SQL interceptado ***\n");
            while (ex != null) {
              System.out.println ("SQLState: " + ex.getSQLState ());
              System.out.println ("Mensaje:  " + ex.getMessage ());
              System.out.println ("Error:   " + ex.getErrorCode ());
              ex = ex.getNextException ();
              System.out.println ("");
            }
        }
        catch (Exception ex) {
            System.out.println ("\n*** Exception interceptado ***\n");
            ex.printStackTrace ();
        }
    }
    private boolean actualizarRecordSetRegistro(String query)
    {
	    boolean fg = false;
	    
        try {
	    abrir();
            int n = stmt.executeUpdate (query);
            if (n > 0)
            	fg = true;
		}
		catch (SQLException ex) {
            System.out.println ("\n*** Error de SQL interceptado ***\n");
            while (ex != null) {
                System.out.println ("SQLState: " + ex.getSQLState ());
                System.out.println ("Mensaje:  " + ex.getMessage ());
                System.out.println ("Error:   " + ex.getErrorCode ());
                ex = ex.getNextException ();
                System.out.println ("");
            }
	}
	catch (Exception ex) {
            ex.printStackTrace ();
	}
		
	cerrar();
	return fg;
    }
    public boolean actualizarRegistro(Datos reg)
    {
        String log = reg.leerValor(0);
        System.out.println("log: " + log);
        String regname = getClassName(reg);
        String textsql = reg.serializarSQL();
        String str = "UPDATE " + regname + " SET " + textsql + " WHERE Login = '" + log + "';";
        System.out.println("sql: " + str);
        if (fg = actualizarRecordSetRegistro(str) == true)
            System.out.println("Se actualizo en " + regname + " record de " + log);
        else
            System.out.println("No se pudo actualizar en " + regname + " record de " + log);

        return fg;
    }

    public void cerrar() {
	System.out.println ("\n*** Cerrando Conexion ***\n");
        try {
          if (con != null)
            con.close();
        }
        catch (SQLException ex) {
            System.out.println ("\n*** Error de SQL interceptado ***\n");
            while (ex != null) {
              System.out.println ("SQLState: " + ex.getSQLState ());
              System.out.println ("Mensaje:  " + ex.getMessage ());
              System.out.println ("Error:   " + ex.getErrorCode ());
              ex = ex.getNextException ();
              System.out.println ("");
            }
        }
    }
//-------------------------------------------------------------------
// checkForWarning
// Verifica y despliega mensajes de advertencia. Regresa Verdadero
// si existe el mensaje de advertencia
//-------------------------------------------------------------------

    private static boolean checkForWarning (SQLWarning warn)
      throws SQLException  {
        boolean rc = false;

    // Si es dado un objeto de SQLWarning, despliega los
    // mensajes de advertencia. Note que pueden existir mltiples
    // mensajes que podran estar encadenados

        if (warn != null) {
            System.out.println ("\n *** Advertencia ***\n");
            rc = true;
            while (warn != null) {
                System.out.println ("SQLState: " + warn.getSQLState ());
                System.out.println ("Mensaje:  " + warn.getMessage ());
                System.out.println ("Error:   " + warn.getErrorCode ());
                System.out.println ("");
                warn = warn.getNextWarning ();
            }
        }
        return rc;
    }
    
    public boolean crearRegistro(Datos reg)
    {
        String log = reg.leerValor(0);
        System.out.println("log: " + log);
        String regname = getClassName(reg);
        String textsql = reg.serializarSQLinsert();
        String querysql = "INSERT INTO " + regname + " " + textsql;
        System.out.println("sql: " + querysql);
        if (fg = actualizarRecordSetRegistro(querysql) == true)
            System.out.println("Se inserto en " + regname + " record de " + log);
        else
            System.out.println("No se pudo insertar en " + regname + " record de " + log);

        return fg;
    }
    // desplegar lectura de BD
    private void displayRecordSet (String query)
    {
        try {
            if (stmt != null) {
                rs = stmt.executeQuery (query);
                dispResultSet(rs);
            }
            else
                return;
        }
        catch (SQLException ex) {
            // Una excepcin de SQL fu generada. La obtiene y
            // despliega el mensaje de error. Note que puede haber
            // mltiples errores que podran encadenarse.
            System.out.println ("\n*** Error de SQL interceptado ***\n");
            while (ex != null) {
                  System.out.println ("SQLState: " + ex.getSQLState ());
                  System.out.println ("Mensaje:  " + ex.getMessage ());
                  System.out.println ("Error:   " + ex.getErrorCode ());
                  ex = ex.getNextException ();
                  System.out.println ("");
            }
        }
        catch (java.lang.Exception ex) {
            // Si existe algn otro error, lo despliega del stack
            ex.printStackTrace ();
        }
    }
    //-------------------------------------------------------------------
    // dispResultSet
    // Despliega todas las lneas y columnas resultado de la seleccin
    //-------------------------------------------------------------------

    private static void dispResultSet (ResultSet rs)
	throws SQLException
    {
	int i;

    // Obtiene el objeto resultado ResultSetMetaData.
    // Este puede ser utilizado para desplegar los nombres
    // de los campos

	ResultSetMetaData rsmd = rs.getMetaData ();

    // Obtiene el nmero de columnas resultado
	int numCols = rsmd.getColumnCount ();

    // Despliega los nombres de los campos
	for (i=1; i<=numCols; i++) {
		if (i > 1) System.out.print(",");
		System.out.print(rsmd.getColumnLabel(i));
	}
	System.out.println("");

    // Despliega informacin hasta que no existan ms registros
	boolean more = rs.next ();
	while (more) {
    // Hace un ciclo por cada columna y la despliega en pantalla
		for (i=1; i<=numCols; i++) {
			if (i > 1) System.out.print(",");
			System.out.print(rs.getString(i));
		}
		System.out.println("");

      // Avanza al siguiente registro
		more = rs.next ();
	}
    }
    public boolean eliminarRegistro(Datos reg)
    {
        String log = reg.leerValor(0);
        System.out.println("log: " + log);
        String regname = getClassName(reg);
        String str = "DELETE FROM " + regname + " WHERE Login = '" + log + "';";
        if (fg = actualizarRecordSetRegistro(str) == true)
            System.out.println("Se elimino en " + regname + " record de " + log);
        else
            System.out.println("No se pudo eliminar en " + regname + " record de " + log);

        return fg;
    }
    // Responsabilidades Privadas
    private boolean leerRecordSetRegistro(String query,Datos datos)
    {
	    boolean fg = false;
        if (datos == null) {
            System.out.println("Datos nulos");
            return false;
        }
        try {
	        abrir();
            rs = stmt.executeQuery (query);
            // Obtiene el objeto resultado ResultSetMetaData.
            // Este puede ser utilizado para desplegar los nombres de los campos
            ResultSetMetaData rsmd = rs.getMetaData ();
            int numCols = rsmd.getColumnCount ();
            System.out.println("Cargando registro");
            if  (rs != null && rs.next()) {
                for (int i = 1; i <= numCols; i++) {  // datos.size()
                    if (i > 1)
                       System.out.print(",");
                    String str = rs.getString(i);
                    System.out.print(str);
                    datos.escribirValor(i-1,str);
                }
                fg = true;
            }
            
            System.out.println("");
	}
	catch (SQLException ex) {
            System.out.println ("\n*** Error de SQL interceptado ***\n");
	    while (ex != null) {
                  System.out.println ("SQLState: " + ex.getSQLState ());
                  System.out.println ("Mensaje:  " + ex.getMessage ());
                  System.out.println ("Error:   " + ex.getErrorCode ());
                  ex = ex.getNextException ();
                  System.out.println ("");
            }
	}
	catch (Exception ex) {
            ex.printStackTrace ();
	}

	cerrar();
        return fg;
    }
    public boolean obtenerRegistro(Datos reg, String log)
    {
        System.out.println("Login: "+log);
        String regname = getClassName(reg);
        String querysql = "SELECT * FROM " + regname + " WHERE (login = '" + log + "')";
        System.out.println("sql: " + querysql);
        if (fg = leerRecordSetRegistro(querysql,reg) == true)
            System.out.println("Se obtuvo registro " + regname + ": " + log);
        else
            System.out.println("No se pudo obtener registro " + regname + ": " + log);

        return fg;
    }
    private int revisarDriverSun()
    {
        int fg = 0;
        try {
            Class.forName ("sun.jdbc.odbc.JdbcOdbcDriver");
            System.out.println ("\n*** Utilizando driver de Sun ***\n");
        }
        catch (ClassNotFoundException ex) {
            System.out.println ("\n*** Sun ClassNotFoundException interceptado ***\n");
            fg = 1;
        }
        return fg;
    }
    public boolean validarRegistro(Datos reg,String log, String pass) {
        System.out.println("Login: "+log);
        System.out.println("Password: "+pass);
        String regname = getClassName(reg);
        String querysql = "SELECT * FROM " + regname + " WHERE (login = '" + log + "') AND (password = '" + pass + "')";
        if (fg = leerRecordSetRegistro(querysql,reg) == true)
            System.out.println("Se valido registro: " + log + "," + pass);
        else
            System.out.println("No se valido registro: " + log + "," + pass);

        return fg;
    }
}
