package registrojdbc;

import java.util.*;

public class ManejadorRegistroUsuario extends Manejador {

        private InterfaceUsuario interfaceUsuario;
	private Pantalla pantallaRegistroUsuario;
	private RegistroUsuario registroUsuario;
	private InterfaceBaseDatosRegistro interfaceRegistro;
        
	public ManejadorRegistroUsuario() {
                pantallaRegistroUsuario = new PantallaRegistroUsuario();
                interfaceUsuario = new InterfaceUsuarioFrame(this,pantallaRegistroUsuario);
                interfaceRegistro = new InterfaceBaseDatosRegistro();
                pantallaRegistroUsuario.setInterfaceUsuario(interfaceUsuario);
                pantallaRegistroUsuario.inicializarInterfaceUsuario();
                interfaceUsuario.desplegarPantalla(pantallaRegistroUsuario);
 	}
	public void manejarEvento(String str) {
            if (str.equals("Registrar"))
		manejarEventoRegistrar();
            else if (str.equals("Consultar"))
		manejarEventoConsultar();
            else if (str.equals("Actualizar"))
		manejarEventoActualizar();
            else if (str.equals("Eliminar"))
		manejarEventoEliminar();
            else if (str.equals("Limpiar"))
		manejarEventoLimpiar();
            else
		manejarEventoSalir();
	}
 
    private void manejarEventoRegistrar() {
         if (registroUsuario == null)
              registroUsuario = new RegistroUsuario();
         interfaceUsuario.leerElementos(pantallaRegistroUsuario,registroUsuario);
         interfaceRegistro.crearRegistro(registroUsuario);
    }
    private void manejarEventoConsultar() {
         if (registroUsuario == null)
              registroUsuario = new RegistroUsuario();
         interfaceUsuario.leerElementos(pantallaRegistroUsuario,registroUsuario);
         String log = registroUsuario.leerValor("login");
         interfaceRegistro.obtenerRegistro(registroUsuario,log);
         interfaceUsuario.escribirElementos(pantallaRegistroUsuario,registroUsuario);
    }
    private void manejarEventoActualizar() {
         if (registroUsuario == null)
              registroUsuario = new RegistroUsuario();
         interfaceUsuario.leerElementos(pantallaRegistroUsuario,registroUsuario);
         interfaceRegistro.actualizarRegistro(registroUsuario);
    }
    private void manejarEventoLimpiar() {
         registroUsuario = new RegistroUsuario();
         interfaceUsuario.escribirElementos(pantallaRegistroUsuario,registroUsuario);
    }
    private void manejarEventoEliminar() {
	 if (registroUsuario == null)
		System.out.println("Registro Invalido");
	 else
                interfaceRegistro.eliminarRegistro(registroUsuario);
         registroUsuario = new RegistroUsuario();
         interfaceUsuario.escribirElementos(pantallaRegistroUsuario,registroUsuario);
    }
    private void manejarEventoSalir() {
         System.exit(0);
    }
    public static void main(String[] args) {
         ManejadorRegistroUsuario m = new ManejadorRegistroUsuario();
    }
}

